package de.bsvrz.buv.plugin.bmvew;

import java.util.List;
import java.util.regex.Pattern;
import java.util.regex.PatternSyntaxException;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.sys.funclib.debug.Debug;

/**
 * ber den Definitionsdialog muss ein Filtereintrag neu angelegt bzw. ein existierender Eintrag gendert werden knnen.
 * 
 * <br>
 * <br>
 * Die Klasse erfllt die technische Anforderungen des Segments Bedienung und Visualisierung (BUV): <br>
 * <ul>
 * <li>TAnf-Vi-BW-C3-10</li>
 * <li>TAnf-Vi-BW-C3-11</li>
 * </ul>
 * 
 * @version $Revision: 1.3 $ / $Date: 2010/02/04 06:06:11 $ / ($Author: HofmannJ $)
 * @author HofmannJ
 * 
 */
public class FilterDefinitionsdialog extends Dialog
{
  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();

  private Filter _betriebsMvFilter = null; // @jve:decl-index=0:

  private EditorRegulaererAusdruck _editorRegulaererAusdruck = null;

  private Shell shell = null; // @jve:decl-index=0:visual-constraint="96,108"

  private Composite composite = null;

  private CLabel labelName = null;

  private Text textName = null;

  private Group groupFilterDefinitionen = null;

  private Composite compositeFilterDef = null;

  private ScrolledComposite compositeFilterDefScroll = null;

  private Composite compositeBottom = null;

  private Button buttonOk = null;

  private Button buttonAbbrechen = null;

  private Button buttonHilfe = null;

  private Label label = null;

  private Text text = null;

  private Button button = null;

  private Label label1 = null;

  private Text text1 = null;

  private Button button1 = null;

  private Label label2 = null;

  private Text text2 = null;

  private Button button2 = null;

  private Label label3;

  private Text text3;

  private Button button3;

  private Label label4;

  private Text text4;

  private Button button4;

  private Label label5;

  private Text text5;

  private Button button5;

  private Label label6;

  private Text text6;

  private Button button6;

  private Label label7;

  private Text text7;

  private Button button7;

  private Label label8;

  private Text text8;

  private Button button8;

  private Label label9;

  private Text text9;

  private Button button9;

  private Label label10;

  private Text text10;

  private Button button10;

  private Label label11;

  private Text text11;

  private Button button11;

  private Label label12;

  private Text text12;

  private Button button12;

  private Label label13;

  private Text text13;

  private Button button13;

  private boolean _bearbeiten;
  private String _nameAlt;
  

  /**
   * Konstruktor fr eine neue Instanz der Klasse {@link FilterDefinitionsdialog}
   * 
   * @param parent
   *          Eltern-Shell, die fr die Darstellung benutzt werden soll.
   */
  public FilterDefinitionsdialog(Shell parent)
  {
    super(parent);
  }

  /**
   * ffnet den Dialog {@link FilterDefinitionsdialog} zum Anlegen eines neuen Filters fr Betriebsmeldungen.
   * 
   * @return Liefert den erzeugten Filter als Instanz der Klasse {@link Filter}.
   */
  public Filter oeffne()
  {
    _bearbeiten = false;
    Shell parent = getParent();
    shell = new Shell(parent, SWT.TITLE | SWT.APPLICATION_MODAL | SWT.MIN | SWT.MAX | SWT.CLOSE);
    // shell = new Shell();
    shell.setText("Definition Filter Betriebsmeldungen");
    // shell.setSize(new Point(400, 300));
    shell.setLayout(new GridLayout());
    createComposite();
    createFilterdefintion();
    createCompositeBottom();
    shell.setSize(new Point(589, 225));

    shell.open();
    //    
    Display display = parent.getDisplay();

    while (!shell.isDisposed())
      if (!display.readAndDispatch())
        display.sleep();

    return _betriebsMvFilter;
  }

  /**
   * ffnet den Dialog {@link FilterDefinitionsdialog} zum Bearbeiten eines bereits erzeugten Filters fr
   * Betriebsmeldungen.
   * 
   * @param betriebsMvDefinitionsdialogFilter
   *          Filter von Betriebsmeldungen, der bearbeitet werden soll.
   * @return Liefert <code>true</code>, falls der Filter bearbeitet wurde, sonst <code>false</code>. Wenn
   *         <code>true</code> geliefert wird, kann der Verwaltungsdialog Filter Betriebsmeldungen ({@link FilterVerwaltungsdialog})
   *         die Darstellung der Liste der Filter aktualisieren.
   */
  public Filter oeffne(Filter betriebsMvDefinitionsdialogFilter, boolean bearbeiten)
  {
    _bearbeiten = bearbeiten;
    _betriebsMvFilter = betriebsMvDefinitionsdialogFilter;
    
    FilterElement lf = _betriebsMvFilter.getLaufendeNummer();
    
    _nameAlt = _betriebsMvFilter.getName();
    
    
    Shell parent = getParent();
    shell = new Shell(parent, SWT.TITLE | SWT.APPLICATION_MODAL | SWT.MIN | SWT.MAX | SWT.CLOSE);
    // shell = new Shell();
    shell.setText("Definition Filter Betriebsmeldungen");
    // shell.setSize(new Point(400, 300));
    shell.setLayout(new GridLayout());
    createComposite();
    createFilterdefintion();
    createCompositeBottom();
    shell.setSize(new Point(589, 225));

    shell.open();
    //    
    Display display = parent.getDisplay();

    while (!shell.isDisposed())
      if (!display.readAndDispatch())
        display.sleep();

    return _betriebsMvFilter;
  }

  /**
   * Generiert die Elemente des Dialogs {@link FilterDefinitionsdialog}.
   * 
   */
  private void generiereGui(FilterElement filterElement)
  {
    EditorRegulaererAusdruck editorRegulaererAusdruck = new EditorRegulaererAusdruck(shell);

    String regEx = editorRegulaererAusdruck.oeffne(filterElement.getRegulaererAusdruck());
   
    if (regEx != null)
    {

      if (filterElement.getFilterElementTitel().equals(Feldbezeichner.ApplikationsID))
      {
        text.setText(regEx);
      }
      else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.LaufendeNummer))
      {
        text1.setText(regEx);
      }
      else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.ApplikationsTyp))
      {
        text2.setText(regEx);
      }
      else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.ApplikationsKennung))
      {
        text3.setText(regEx);
      }
      else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.ID))
      {
        text4.setText(regEx);
      }
      else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.MeldungsTyp))
      {
        text5.setText(regEx);
      }
      else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.MeldungsTypZusatz))
      {
        text6.setText(regEx);
      }
      else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.MeldungsKlasse))
      {
        text7.setText(regEx);
      }
      else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.Referenz))
      {
        text8.setText(regEx);
      }
      else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.Status))
      {
        text9.setText(regEx);
      }
      else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.UrlasserBenutzerReferenz))
      {
        text10.setText(regEx);
      }
      else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.UrlasserUrsache))
      {
        text11.setText(regEx);
      }
      else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.UrlasserVeranlasser))
      {
        text12.setText(regEx);
      }
      else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.MeldungsText))
      {
        text13.setText(regEx);
      }

    }

  }

  /**
   * bernimmt die aktuellen Einstellungen. Dabei wird geprft,
   * <ul>
   * <li>ob eine Filterdefinition eingegeben wurde</li>
   * <li>dass ein Name eingegeben wurde</li>
   * </ul>
   * 
   */
  private void aktionOk()
  {
   
    if (textName != null && !textName.getText().isEmpty())
    {
           
      FilterSpeicher filterSpeicher = FilterSpeicher.getInstanz();
      
      List<Filter> filterListe = filterSpeicher.getFilterListe();
      
      for (Filter filter : filterListe)
      {
        if (filter.getName().equals(textName.getText())){
                    
          //if (!_bearbeiten)          
          if (!_nameAlt.equals(textName.getText()))
          {              
            MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
            mb.setText("Fehler Definition");
            mb.setMessage("Filter schon vorhanden: " + filter.getName());
            mb.open();
            return;
          }
        }
      }
      
      _betriebsMvFilter.setName(textName.getText());
      
      Pattern p = null;
      FilterElement fe = null;
      try
      {
        fe = _betriebsMvFilter.getApplikationsID();
        p = Pattern.compile(fe.getRegulaererAusdruck());
        if (p != null){
          text.setText(fe.getRegulaererAusdruck());
          _betriebsMvFilter.setApplikationsID(fe);
        }
        fe = _betriebsMvFilter.getLaufendeNummer();
        p = Pattern.compile(fe.getRegulaererAusdruck());
        if (p != null){
          text1.setText(fe.getRegulaererAusdruck());
          _betriebsMvFilter.setLaufendeNummer(fe);
        }
        fe = _betriebsMvFilter.getApplikationsTyp();
        p = Pattern.compile(fe.getRegulaererAusdruck());
        if (p != null){
          text2.setText(fe.getRegulaererAusdruck());
          _betriebsMvFilter.setApplikationsTyp(fe);
        }
        fe = _betriebsMvFilter.getApplikationsKennung();
        p = Pattern.compile(fe.getRegulaererAusdruck());
        if (p != null){
          text3.setText(fe.getRegulaererAusdruck());
          _betriebsMvFilter.setApplikationsKennung(fe);
        }
        fe = _betriebsMvFilter.getID();          
        p = Pattern.compile(fe.getRegulaererAusdruck());
        if (p != null){
          text4.setText(fe.getRegulaererAusdruck());
          _betriebsMvFilter.setID(fe);
        }
        fe = _betriebsMvFilter.getMeldungsTyp();          
        p = Pattern.compile(fe.getRegulaererAusdruck());
        if (p != null){
          text5.setText(fe.getRegulaererAusdruck());
          _betriebsMvFilter.setMeldungsTyp(fe);
        }
        fe = _betriebsMvFilter.getMeldungsTypZusatz();          
        p = Pattern.compile(fe.getRegulaererAusdruck());
        if (p != null){
          text6.setText(fe.getRegulaererAusdruck());
          _betriebsMvFilter.setMeldungsTypZusatz(fe);
        }
        fe = _betriebsMvFilter.getMeldungsKlasse();         
        p = Pattern.compile(fe.getRegulaererAusdruck());
        if (p != null){
          text7.setText(fe.getRegulaererAusdruck());
          _betriebsMvFilter.setMeldungsKlasse(fe);
        }
        fe = _betriebsMvFilter.getReferenz();
        p = Pattern.compile(fe.getRegulaererAusdruck());
        if (p != null){
          text8.setText(fe.getRegulaererAusdruck());
          _betriebsMvFilter.setReferenz(fe);
        }
        fe = _betriebsMvFilter.getStatus();
        p = Pattern.compile(fe.getRegulaererAusdruck());
        if (p != null){
          text9.setText(fe.getRegulaererAusdruck());
          _betriebsMvFilter.setStatus(fe);
        }
        fe = _betriebsMvFilter.getUrlasserBenutzerReferenz();          
        p = Pattern.compile(fe.getRegulaererAusdruck());
        if (p != null){
          text10.setText(fe.getRegulaererAusdruck());
          _betriebsMvFilter.setUrlasserBenutzerReferenz(fe);
        }
        fe = _betriebsMvFilter.getUrlasserUrsache();          
        p = Pattern.compile(fe.getRegulaererAusdruck());
        if (p != null){
          text11.setText(fe.getRegulaererAusdruck());
          _betriebsMvFilter.setUrlasserUrsache(fe);
        }
        fe = _betriebsMvFilter.getUrlasserVeranlasser();          
        p = Pattern.compile(fe.getRegulaererAusdruck());
        if (p != null){
          text12.setText(fe.getRegulaererAusdruck());
          _betriebsMvFilter.setUrlasserVeranlasser(fe);
        }
        fe = _betriebsMvFilter.getMeldungsText();
        p = Pattern.compile(fe.getRegulaererAusdruck());
        if (p != null){
          text13.setText(fe.getRegulaererAusdruck());
          _betriebsMvFilter.setMeldungsText(fe);
        }
        
      }
      catch (PatternSyntaxException e)
      {
        _debug.fine("Fehler: " + fe.getRegulaererAusdruck());         
        MessageBox mb = new MessageBox(shell, SWT.ICON_INFORMATION | SWT.OK);
        mb.setText("Fehler Definition");
        mb.setMessage("FilterElement ist ungueltig: " + fe.getFilterElementTitel());
        mb.open();
        return;
       
      }
     

      /*
      
      List<FilterElement> fes = _betriebsMvFilter.getFilterElemente();
      
      FilterElement flf = _betriebsMvFilter.getLaufendeNummer();
      
      System.out.println(flf.getFilterElementTitel() + " : " + flf.getRegulaererAusdruck());
      
      for (FilterElement filterElement : fes)
      {
        Pattern p = null;
        try
        {
          p = Pattern.compile(filterElement.getRegulaererAusdruck());
        }
        catch (PatternSyntaxException e)
        {
          _debug.fine("Fehler: " + filterElement.getRegulaererAusdruck());
        }
     
        if (p != null){
        
          if (filterElement.getFilterElementTitel().equals(Feldbezeichner.ApplikationsID))
          {
            text.setText(filterElement.getRegulaererAusdruck());
            _betriebsMvFilter.setApplikationsID(filterElement);
          }
          else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.LaufendeNummer))
          {
            text1.setText(filterElement.getRegulaererAusdruck());
            _betriebsMvFilter.setLaufendeNummer(filterElement);
          }
          else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.ApplikationsTyp))
          {
            text2.setText(filterElement.getRegulaererAusdruck());
            _betriebsMvFilter.setApplikationsTyp(filterElement);
          }
          else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.ApplikationsKennung))
          {
            text3.setText(filterElement.getRegulaererAusdruck());
            _betriebsMvFilter.setApplikationsKennung(filterElement);
          }
          else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.ID))
          {
            text4.setText(filterElement.getRegulaererAusdruck());
            _betriebsMvFilter.setID(filterElement);
          }
          else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.MeldungsTyp))
          {
            text5.setText(filterElement.getRegulaererAusdruck());
            _betriebsMvFilter.setMeldungsTyp(filterElement);
          }
          else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.MeldungsTypZusatz))
          {
            text6.setText(filterElement.getRegulaererAusdruck());
            _betriebsMvFilter.setMeldungsTypZusatz(filterElement);
          }
          else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.MeldungsKlasse))
          {
            text7.setText(filterElement.getRegulaererAusdruck());
            _betriebsMvFilter.setMeldungsKlasse(filterElement);
          }
          else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.Referenz))
          {
            text8.setText(filterElement.getRegulaererAusdruck());
            _betriebsMvFilter.setReferenz(filterElement);
          }
          else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.Status))
          {
            text9.setText(filterElement.getRegulaererAusdruck());
            _betriebsMvFilter.setStatus(filterElement);
          }
          else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.UrlasserBenutzerReferenz))
          {
            text10.setText(filterElement.getRegulaererAusdruck());
            _betriebsMvFilter.setUrlasserBenutzerReferenz(filterElement);
          }
          else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.UrlasserUrsache))
          {
            text11.setText(filterElement.getRegulaererAusdruck());
            _betriebsMvFilter.setUrlasserUrsache(filterElement);
          }
          else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.UrlasserVeranlasser))
          {
            text12.setText(filterElement.getRegulaererAusdruck());
            _betriebsMvFilter.setUrlasserVeranlasser(filterElement);
          }
          else if (filterElement.getFilterElementTitel().equals(Feldbezeichner.MeldungsText))
          {
            text13.setText(filterElement.getRegulaererAusdruck());
            _betriebsMvFilter.setMeldungsText(filterElement);
          }else
            System.out.println("Fehler: " + filterElement.getFilterElementTitel() + " : " + filterElement.getRegulaererAusdruck());
          
        
        }else{
          MessageBox mb = new MessageBox(shell, SWT.ICON_INFORMATION | SWT.OK);
          mb.setText("Fehler Definition");
          mb.setMessage("FilterElement ist ungueltig: " + filterElement.getFilterElementTitel());
          mb.open();
          return;
        }

      }
      */

      shell.dispose();

    }else{
      MessageBox mb = new MessageBox(shell, SWT.ICON_INFORMATION | SWT.OK);
      mb.setText("Fehler Definition");
      mb.setMessage("Es muss ein Name Angegeben werden!");
      mb.open();
      return;
    }
    
  }

  /**
   * Schliet den Dialog {@link FilterDefinitionsdialog} ohne bernahme der Einstellungen.
   * 
   */
  private void aktionAbbrechen()
  {
      _betriebsMvFilter = null;
      shell.dispose();
  }

  /**
   * Zeigt die Hilfe zum Dialog {@link FilterDefinitionsdialog} an.
   * 
   */
  private void aktionHilfe()
  {
    String contextId = Aktivator.PLUGIN_ID + ".betriebsmeldungsverwaltung";
    _debug.fine("ContextID: " + contextId);
    PlatformUI.getWorkbench().getHelpSystem().displayHelp(contextId);
  }

  /**
   * This method initializes composite
   * 
   */
  private void createComposite()
  {
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.verticalAlignment = GridData.CENTER;
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 2;
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.verticalAlignment = GridData.CENTER;
    composite = new Composite(shell, SWT.NONE);
    composite.setLayoutData(gridData);
    composite.setLayout(gridLayout);
    labelName = new CLabel(composite, SWT.NONE);
    labelName.setText("Name");
    textName = new Text(composite, SWT.BORDER);
    textName.setLayoutData(gridData1);
    textName.addModifyListener(new ModifyListener() {

      @Override
      public void modifyText(ModifyEvent e)
      {
        //_betriebsMvFilter.setName(textName.getText());
      }
    });
    textName.setText(_betriebsMvFilter.getName());
  }

  /**
   * This method initializes Filterdefintion
   * 
   */
  private void createFilterdefintion()
  {
    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.FILL;
    gridData2.grabExcessVerticalSpace = true;
    gridData2.grabExcessHorizontalSpace = true;
    gridData2.verticalAlignment = GridData.CENTER;
    groupFilterDefinitionen = new Group(shell, SWT.NONE);
    groupFilterDefinitionen.setLayout(new FillLayout());
    groupFilterDefinitionen.setLayoutData(gridData2);
    createCompositeFilterDef();
    groupFilterDefinitionen.setText("Filterdefinitionen");
  }

  /**
   * This method initializes compositeFilterDef
   * 
   */
  private void createCompositeFilterDef()
  {

    GridData gridData9 = new GridData();
    gridData9.horizontalAlignment = GridData.FILL;
    gridData9.verticalAlignment = GridData.CENTER;
    GridData gridData7 = new GridData();
    gridData7.horizontalAlignment = GridData.FILL;
    gridData7.verticalAlignment = GridData.CENTER;
    GridData gridData6 = new GridData();
    gridData6.horizontalAlignment = GridData.FILL;
    gridData6.grabExcessHorizontalSpace = true;
    gridData6.verticalAlignment = GridData.CENTER;
    GridData gridData5 = new GridData();
    gridData5.horizontalAlignment = GridData.FILL;
    gridData5.grabExcessHorizontalSpace = true;
    gridData5.grabExcessVerticalSpace = false;
    gridData5.verticalAlignment = GridData.CENTER;
    GridLayout gridLayout1 = new GridLayout();
    gridLayout1.numColumns = 3;
    GridData gridData8 = new GridData();
    gridData8.horizontalAlignment = GridData.FILL;
    gridData8.grabExcessHorizontalSpace = true;
    gridData8.verticalAlignment = GridData.CENTER;

    compositeFilterDefScroll = new ScrolledComposite(groupFilterDefinitionen, SWT.V_SCROLL);
    // Hier wird schneller gescrolled
    compositeFilterDefScroll.getVerticalBar().setIncrement(compositeFilterDefScroll.getVerticalBar().getIncrement()*10);
    
    compositeFilterDef = new Composite(compositeFilterDefScroll, SWT.NONE);
    compositeFilterDef.setLayout(gridLayout1);
    label = new Label(compositeFilterDef, SWT.NONE);
    label.setText("ApplikationsId");
    text = new Text(compositeFilterDef, SWT.BORDER);
    text.setLayoutData(gridData5);
    if (_betriebsMvFilter != null)
    {
      text.setText(_betriebsMvFilter.getApplikationsID().getRegulaererAusdruck());
      text.addModifyListener(new ModifyListener() {

        @Override
        public void modifyText(ModifyEvent e)
        {
          _betriebsMvFilter.getApplikationsID().setRegulaererAusdruck(text.getText());
        }
      });
    }
    button = new Button(compositeFilterDef, SWT.NONE);
    button.setText("...");    
    button.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				generiereGui(_betriebsMvFilter.getApplikationsID());
			}			
		});

    label1 = new Label(compositeFilterDef, SWT.NONE);
    label1.setText("LaufendeNummer");
    text1 = new Text(compositeFilterDef, SWT.BORDER);
    text1.setLayoutData(gridData6);
    if (_betriebsMvFilter != null)
    {
      text1.setText(_betriebsMvFilter.getLaufendeNummer().getRegulaererAusdruck());
      text1.addModifyListener(new ModifyListener() {

        @Override
        public void modifyText(ModifyEvent e)
        {
          _betriebsMvFilter.getLaufendeNummer().setRegulaererAusdruck(text1.getText());
        }
      });
    }
    button1 = new Button(compositeFilterDef, SWT.NONE);
    button1.setText("...");   
    button1.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				generiereGui(_betriebsMvFilter.getLaufendeNummer());
			}			
		});

    label2 = new Label(compositeFilterDef, SWT.NONE);
    label2.setText("ApplikationsTyp");
    text2 = new Text(compositeFilterDef, SWT.BORDER);
    text2.setLayoutData(gridData7);
    if (_betriebsMvFilter != null)
    {
      text2.setText(_betriebsMvFilter.getApplikationsTyp().getRegulaererAusdruck());
      text2.addModifyListener(new ModifyListener() {

        @Override
        public void modifyText(ModifyEvent e)
        {
          _betriebsMvFilter.getApplikationsTyp().setRegulaererAusdruck(text2.getText());
        }
      });
    }
    button2 = new Button(compositeFilterDef, SWT.NONE);
    button2.setText("...");
    button2.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				generiereGui(_betriebsMvFilter.getApplikationsTyp());
			}			
		});

    label3 = new Label(compositeFilterDef, SWT.NONE);
    label3.setText("ApplikationsKennung");
    text3 = new Text(compositeFilterDef, SWT.BORDER);
    text3.setLayoutData(gridData9);
    if (_betriebsMvFilter != null)
    {
      text3.setText(_betriebsMvFilter.getApplikationsKennung().getRegulaererAusdruck());
      text3.addModifyListener(new ModifyListener() {

        @Override
        public void modifyText(ModifyEvent e)
        {
          _betriebsMvFilter.getApplikationsKennung().setRegulaererAusdruck(text3.getText());
        }
      });
    }
    button3 = new Button(compositeFilterDef, SWT.NONE);
    button3.setText("...");
    button3.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				generiereGui(_betriebsMvFilter.getApplikationsKennung());
			}			
		});

    label4 = new Label(compositeFilterDef, SWT.NONE);
    label4.setText("ID");
    text4 = new Text(compositeFilterDef, SWT.BORDER);
    text4.setLayoutData(gridData9);
    if (_betriebsMvFilter != null)
    {
      text4.setText(_betriebsMvFilter.getID().getRegulaererAusdruck());
      text4.addModifyListener(new ModifyListener() {

        @Override
        public void modifyText(ModifyEvent e)
        {
          _betriebsMvFilter.getID().setRegulaererAusdruck(text4.getText());
        }
      });
    }
    button4 = new Button(compositeFilterDef, SWT.NONE);
    button4.setText("...");    
    button4.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				generiereGui(_betriebsMvFilter.getID());
			}			
		});

    label5 = new Label(compositeFilterDef, SWT.NONE);
    label5.setText("MeldungsTyp");
    text5 = new Text(compositeFilterDef, SWT.BORDER);
    text5.setLayoutData(gridData9);
    if (_betriebsMvFilter != null)
    {
      text5.setText(_betriebsMvFilter.getMeldungsTyp().getRegulaererAusdruck());
      text5.addModifyListener(new ModifyListener() {

        @Override
        public void modifyText(ModifyEvent e)
        {
          _betriebsMvFilter.getMeldungsTyp().setRegulaererAusdruck(text5.getText());
        }
      });

    }
    button5 = new Button(compositeFilterDef, SWT.NONE);
    button5.setText("...");
    button5.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				generiereGui(_betriebsMvFilter.getMeldungsTyp());
			}			
		});

    label6 = new Label(compositeFilterDef, SWT.NONE);
    label6.setText("MeldungsTypZusatz");
    text6 = new Text(compositeFilterDef, SWT.BORDER);
    text6.setLayoutData(gridData9);
    if (_betriebsMvFilter != null)
    {
      text6.setText(_betriebsMvFilter.getMeldungsTypZusatz().getRegulaererAusdruck());
      text5.addModifyListener(new ModifyListener() {

        @Override
        public void modifyText(ModifyEvent e)
        {
          _betriebsMvFilter.getMeldungsTypZusatz().setRegulaererAusdruck(text6.getText());
        }
      });
    }
    button6 = new Button(compositeFilterDef, SWT.NONE);
    button6.setText("...");
    button6.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				generiereGui(_betriebsMvFilter.getMeldungsTypZusatz());
			}			
		});

    label7 = new Label(compositeFilterDef, SWT.NONE);
    label7.setText("MeldungsKlasse");
    text7 = new Text(compositeFilterDef, SWT.BORDER);
    text7.setLayoutData(gridData9);
    if (_betriebsMvFilter != null)
    {
      text7.setText(_betriebsMvFilter.getMeldungsKlasse().getRegulaererAusdruck());
      text7.addModifyListener(new ModifyListener() {

        @Override
        public void modifyText(ModifyEvent e)
        {
          _betriebsMvFilter.getMeldungsKlasse().setRegulaererAusdruck(text7.getText());
        }
      });
    }
    button7 = new Button(compositeFilterDef, SWT.NONE);
    button7.setText("...");
    button7.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				generiereGui(_betriebsMvFilter.getMeldungsKlasse());
			}			
		});

    label8 = new Label(compositeFilterDef, SWT.NONE);
    label8.setText("Referenz");
    text8 = new Text(compositeFilterDef, SWT.BORDER);
    text8.setLayoutData(gridData9);
    if (_betriebsMvFilter != null)
    {
      text8.setText(_betriebsMvFilter.getReferenz().getRegulaererAusdruck());
      text8.addModifyListener(new ModifyListener() {

        @Override
        public void modifyText(ModifyEvent e)
        {
          _betriebsMvFilter.getReferenz().setRegulaererAusdruck(text8.getText());
        }
      });
    }
    button8 = new Button(compositeFilterDef, SWT.NONE);
    button8.setText("...");
    button8.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				generiereGui(_betriebsMvFilter.getReferenz());
			}			
		});

    label9 = new Label(compositeFilterDef, SWT.NONE);
    label9.setText("Status");
    text9 = new Text(compositeFilterDef, SWT.BORDER);
    text9.setLayoutData(gridData9);
    if (_betriebsMvFilter != null)
    {
      text9.setText(_betriebsMvFilter.getStatus().getRegulaererAusdruck());
      text9.addModifyListener(new ModifyListener() {

        @Override
        public void modifyText(ModifyEvent e)
        {
          _betriebsMvFilter.getStatus().setRegulaererAusdruck(text9.getText());
        }
      });
    }
    button9 = new Button(compositeFilterDef, SWT.NONE);
    button9.setText("...");
    button9.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				generiereGui(_betriebsMvFilter.getStatus());
			}			
		});

    label10 = new Label(compositeFilterDef, SWT.NONE);
    label10.setText("BenutzerReferenz");
    text10 = new Text(compositeFilterDef, SWT.BORDER);
    text10.setLayoutData(gridData9);
    if (_betriebsMvFilter != null)
    {
      text10.setText(_betriebsMvFilter.getUrlasserBenutzerReferenz().getRegulaererAusdruck());
      text10.addModifyListener(new ModifyListener() {

        @Override
        public void modifyText(ModifyEvent e)
        {
          _betriebsMvFilter.getUrlasserBenutzerReferenz().setRegulaererAusdruck(text10.getText());
        }
      });
    }
    button10 = new Button(compositeFilterDef, SWT.NONE);
    button10.setText("...");
    button10.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				generiereGui(_betriebsMvFilter.getUrlasserBenutzerReferenz());
			}			
		});

    label11 = new Label(compositeFilterDef, SWT.NONE);
    label11.setText("Ursache");
    text11 = new Text(compositeFilterDef, SWT.BORDER);
    text11.setLayoutData(gridData9);
    if (_betriebsMvFilter != null)
    {
      text11.setText(_betriebsMvFilter.getUrlasserUrsache().getRegulaererAusdruck());
      text11.addModifyListener(new ModifyListener() {

        @Override
        public void modifyText(ModifyEvent e)
        {
          _betriebsMvFilter.getUrlasserUrsache().setRegulaererAusdruck(text11.getText());
        }
      });
    }
    button11 = new Button(compositeFilterDef, SWT.NONE);
    button11.setText("...");
    button11.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				generiereGui(_betriebsMvFilter.getUrlasserUrsache());
			}			
		});

    label12 = new Label(compositeFilterDef, SWT.NONE);
    label12.setText("Veranlasser");
    text12 = new Text(compositeFilterDef, SWT.BORDER);
    text12.setLayoutData(gridData9);
    if (_betriebsMvFilter != null)
    {
      text12.setText(_betriebsMvFilter.getUrlasserVeranlasser().getRegulaererAusdruck());
      text12.addModifyListener(new ModifyListener() {

        @Override
        public void modifyText(ModifyEvent e)
        {
          _betriebsMvFilter.getUrlasserVeranlasser().setRegulaererAusdruck(text12.getText());
        }
      });
    }
    button12 = new Button(compositeFilterDef, SWT.NONE);
    button12.setText("...");
    button12.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				generiereGui(_betriebsMvFilter.getUrlasserVeranlasser());
			}			
		});

    label13 = new Label(compositeFilterDef, SWT.NONE);
    label13.setText("MeldungsText");
    text13 = new Text(compositeFilterDef, SWT.BORDER);
    text13.setLayoutData(gridData9);
    if (_betriebsMvFilter != null)
    {
      text13.setText(_betriebsMvFilter.getMeldungsText().getRegulaererAusdruck());
      text13.addModifyListener(new ModifyListener() {

        @Override
        public void modifyText(ModifyEvent e)
        {
          _betriebsMvFilter.getMeldungsText().setRegulaererAusdruck(text13.getText());
        }
      });
    }
    button13 = new Button(compositeFilterDef, SWT.NONE);
    button13.setText("...");   
    button13.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				generiereGui(_betriebsMvFilter.getMeldungsText());
			}			
		});

    compositeFilterDefScroll.setContent(compositeFilterDef);
    compositeFilterDef.layout();
    // _verschiebbaresCompositeZeitgruppen.setMinSize(600, 4000);
    compositeFilterDefScroll.setLayout(new FillLayout());
    compositeFilterDefScroll.setExpandHorizontal(true);
    compositeFilterDefScroll.setExpandVertical(true);

    compositeFilterDefScroll.setMinSize(compositeFilterDef.computeSize(SWT.DEFAULT, SWT.DEFAULT));
    compositeFilterDef.layout();

  }

  /**
   * This method initializes compositeBottom
   * 
   */
  private void createCompositeBottom()
  {
    RowLayout rowLayout = new RowLayout();
    rowLayout.pack = false;
    GridData gridData3 = new GridData();
    gridData3.horizontalAlignment = GridData.END;
    gridData3.grabExcessHorizontalSpace = true;
    gridData3.verticalAlignment = GridData.CENTER;
    compositeBottom = new Composite(shell, SWT.NONE);
    compositeBottom.setLayoutData(gridData3);
    compositeBottom.setLayout(rowLayout);
    buttonOk = new Button(compositeBottom, SWT.NONE);
    buttonOk.setText("Ok");    
    buttonOk.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionOk();
			}			
		});

    buttonAbbrechen = new Button(compositeBottom, SWT.NONE);
    buttonAbbrechen.setText("Abbrechen");  
    buttonAbbrechen.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionAbbrechen();
			}			
		});
    
    buttonHilfe = new Button(compositeBottom, SWT.NONE);
    buttonHilfe.setText("Hilfe");   
    buttonHilfe.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionHilfe();
			}			
		});
  }

}
