package de.bsvrz.buv.plugin.bmvew;

import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Shell;

import de.bsvrz.sys.funclib.debug.Debug;

/**
 * Nach Auswahl des Menpunkts "Betriebsmeldungen..." in der Rahmenapplikation muss sich der Dialog zur Anzeige der
 * Betriebsmeldungen ffnen.
 * 
 * <br>
 * <br>
 * Die Klasse erfllt die technische Anforderungen des Segments Bedienung und Visualisierung (BUV): <br>
 * <ul>
 * <li>TAnf-Vi-BW-C3-8</li>
 * </ul>
 * 
 * @version $Revision: 1.2 $ / $Date: 2010/02/02 15:40:41 $ / ($Author: HofmannJ $)
 * @author HofmannJ
 * 
 */
public class MeldungsanzeigeDialog extends Dialog
{

  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();

  /**
   * Meldungen Speicher
   */
  private MeldungenSpeicher _meldungenSpeicher = MeldungenSpeicher.getInstanz();

  /**
   * Filter Speicher
   */
  private FilterSpeicher _filterSpeicher = null;

  /**
   * Gibt an, ob der Filter fr den Betriebsmeldungsdialog aktiv (<code>true</code>) oder inaktiv (<code>false</code>)ist.
   */
  private boolean _filterAktiv = false;

  /**
   * Gibt an, welcher Filter gewhlt wurde
   */
  private Filter _filter = null;

  /**
   * TableViewer, der die Betriebsmeldungen darstellt.
   */
  private TableViewer _tvBetriebsMeldungen = null;

  /**
   * Gibt die Sortierreihenfolge der Spalten an.
   */
  private int[] _tvSpaltenSortierung = null;

  /**
   * Konstruktor fr neue Instanzen der Klasse {@link MeldungsanzeigeDialog}.
   * 
   * @param parent
   *          Eltern-Shell, die fr die Darstellung benutzt werden soll.
   */
  public MeldungsanzeigeDialog(Shell parent)
  {
    super(parent);    
    _filterSpeicher = FilterSpeicher.getInstanz();
  }

  /**
   * ffnet den Dialog {@link MeldungsanzeigeDialog}.
   * 
   */
  public void open()
  {
    // Neue Shell anlegen, Wait & Dispose, evtl. Rckgabewerte.
  }

  /**
   * Generiert die Elemente des Dialogs {@link MeldungsanzeigeDialog}.
   * 
   */
  private void generiereGui()
  {
  }

  /**
   * ffnet die Verwaltung der Filter, dort lassen sich Filter anlegen, bearbeiten, kopieren und lschen.
   * 
   */
  private void aktionFilterVerwalten()
  {
    FilterVerwaltungsdialog filterVerwaltungsdialog = new FilterVerwaltungsdialog(this.getParent());
    filterVerwaltungsdialog.oeffne(this._filterSpeicher);
  }

  /**
   * ffnet die Hilfe zum Dialog {@link MeldungsanzeigeDialog}.
   * 
   */
  private void aktionHilfe()
  {
  }

  /**
   * Schliet den Dialog {@link MeldungsanzeigeDialog}.
   * 
   * Betriebsmeldungen werden auch nach dem Schlieen des Dialogs gespeichert, so dass beim nchsten ffnen des Fensters
   * alle bisher empfangenen Betriebsmeldungen (bis zur maximalen Anzahl) dargestellt werden.
   * 
   */
  private void aktionSchliessen()
  {
  }

  /**
   * Fr den Button ok ist keinerlei Funktionalitt vorgegeben.
   * 
   */
  private void aktionOk()
  {
  }

  /**
   * Fllt die Liste der Betriebsmeldungen des Dialogs.
   */
  private void fuelleDialogBetriebsmeldungsListe()
  {
  }

  /**
   * Speichert die Spaltenreihenfolge ab.
   * 
   */
  private void spaltenSortierungSpeichern()
  {

    // /*
    // * Aktivierung der Spaltensortierbarkeit geht spaltenweise:
    // */
    // TableColumn[] columns = _tvBetriebsMeldungen.getTable().getColumns();
    // for(int j = 0; j < columns.length; j++)
    // {
    // columns[j].setMoveable(true);
    // }

    String ordnung = "(";
    // Auslesen der Spaltenordnung
    int[] order = _tvBetriebsMeldungen.getTable().getColumnOrder();
    for (int i = 0; i < order.length; i++)
    {
      ordnung = ordnung + "[" + order[i] + "] ";
    }
    ordnung = ordnung + ")";
    _debug.fine("Spaltensortierung: " + ordnung);
  }

  /**
   * Ld die Sortierung der Spalten.
   * 
   */
  private void spaltenSortierungLaden()
  {
    // Setzen der Spaltenordnung
    // _tvBetriebsMeldungen.getTable().setColumnOrder(order)
  }

  /**
   * Kopiert die selektierten Zeilen der Betriebsmeldungstabelle in die Zwischenablage, die Werte in den Spalten werden
   * durch Tabulatoren getrennt.
   * 
   */
  private void kopiereSelektierteZeilen()
  {
    /*
     * Stichwort: TextTransfer.getInstance() Beispiel:
     * http://www.java2s.com/Code/Java/SWT-JFace-Eclipse/SWTClipboardExample.htm
     */
  }

}
