package de.bsvrz.buv.plugin.engstvw;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Shell;

/**
 * ber den Definitionsdialog muss ein Engstelleneintrag neu angelegt bzw. ein existierender Eintrag gendert werden
 * knnen.
 * 
 * <br>
 * <br>
 * Die Klasse erfllt die technische Anforderungen des Segments Bedienung und Visualisierung (BUV): <br>
 * <ul>
 * <li>TAnf-Vi-BW-C3-13</li>
 * </ul>
 * 
 * @version $Revision: 1.1 $ / $Date: 2010/02/02 15:21:25 $ / ($Author: HofmannJ $)
 * @author HofmannJ
 * @deprecated Nur die Klasse {@link Definitionsdialog} verwenden!
 */
public class DefinitionsdialogAlt extends Dialog
{
  /**
   * Datemstruktur der Engstelle.
   */
  private Engstelle _engstelleDatensatz = null;

  /**
   * Konstruktor fr neue Instanzen der Klasse {@link DefinitionsdialogAlt}.
   * 
   * @param parent
   *          Eltern-Shell, die fr die Darstellung benutzt werden soll.
   */
  public DefinitionsdialogAlt(Shell parent)
  {
    super(parent);
  }

  /**
   * ffnet den Dialog {@link DefinitionsdialogAlt} zum Anlegen einer einer neuen Engstelle (Datensatz vom Typ
   * {@link Engstelle}).
   * 
   * @return Liefert den erfassten Datensatz vom Typ {@link Engstelle} ode <code>null</code>.
   */
  public Engstelle oeffne()
  {
    return _engstelleDatensatz;
  }

  /**
   * ffnet den Dialog {@link DefinitionsdialogAlt} zum Bearbeiten eine Datensatzes vom Typ {@link Engstelle}.
   * 
   * @param engstelleDatensatz
   *          Datensatz, der bearbeitet werden soll.
   * @return Liefert <code>true</code>, wenn der Datensatz bearbeitet wurde, sonst <code>false</code>. Bei
   *         <code>true</code> kann der Dialog {@link Verwaltungsdialog} die Liste der Engstellen aktuallisieren.
   */
  public boolean oeffne(Engstelle engstelleDatensatz)
  {
    this._engstelleDatensatz = engstelleDatensatz;
    return false;
  }

  /**
   * Generiert die Elemente des Dialogs {@link DefinitionsdialogAlt}.
   * 
   */
  private void generiereGui()
  {
  }

  /**
   * bernimmt die aktuellen Einstellungen. Dabei wird geprft: <br>
   * <ul>
   * <li>dass ein Name eingegeben und ein Engstellentyp ausgewhlt wurde,</li>
   * <li>ob ein Status ausgewhlt wurde, wenn "Baustelle" ausgewhlt wurde,</li>
   * <li>ob eine Restkapazitt eingegeben wurde.</li>
   * <li>ob "Lage von" und "Lage bis" ausgewhlt wurden.</li> *
   * <li>ob die Zeitangaben gltig sind.</li>
   * </ul>
   * <br>
   * Falls nicht, wird eine entsprechende Fehlermeldung ausgegeben.
   * 
   */
  private void actionOk()
  {

  }

  /**
   * Schliet den Dialog ohne bernahme der getroffenen Eingstellungen.
   * 
   */
  private void aktionAbbrechen()
  {

  }

  /**
   * Zeigt die Hilfe zum Dialog {@link DefinitionsdialogAlt} an.
   * 
   */
  private void aktionHilfe()
  {

  }

}
