/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.plugin.pruefrw;

import org.eclipse.core.resources.ISaveParticipant;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

/**
 * The activator class controls the plug-in life cycle Der Aktivator (erweitert
 * {@link AbstractUIPlugin}), kontrolliert den Lebenszyklus eines Plug-Ins.
 * <br>
 * <br>
 * Es bietet sich an, im Aktivator die Registrierung eines
 * {@link ISaveParticipant} durchzufhren, mit dessen Hilfe der Zustand des
 * Plug-Ins bei Beendigung des Rahmenwerkes gesichert werden kann.
 */
public class Aktivator extends AbstractUIPlugin
{
	// The plug-in ID
	public static final String PLUGIN_ID = "de.bsvrz.buv.plugin.pruefrw";

	// The shared instance
	private static Aktivator plugin;

	/**
	 * The constructor
	 */
	public Aktivator()
	{
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception
	{
		super.start(context);
		plugin = this;

		/*
		 * Erzeugen eines neuen ISaveParticipant
		 */
		ISaveParticipant saveParticipant = new Saver();

		/*
		 * Registrieren des ISaveParticipant
		 */
		ResourcesPlugin.getWorkspace().addSaveParticipant(this, saveParticipant);

		/*
		 * Ein Beispiel, wie der Logger von Eclipse zu verwenden ist.
		 */
		// getLog().log(
		// new Status(Status.INFO, Aktivator.PLUGIN_ID, Status.OK,
		//						"Eine Meldung des PruefRw-Aktivators zu Testzwecken.", null));

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception
	{
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 * 
	 * @return the shared instance
	 */
	public static Aktivator getDefault()
	{
		return plugin;
	}

	/**
	 * Returns an image descriptor for the image file at the given plug-in
	 * relative path
	 * 
	 * @param path
	 *          the path
	 * @return the image descriptor
	 */
	public static ImageDescriptor getImageDescriptor(String path)
	{
		return imageDescriptorFromPlugin(PLUGIN_ID, path);
	}

}
