/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.plugin.pruefrw.tabellen;

import de.bsvrz.buv.rw.basislib.tabellen.ITabellenZeile;

public class ZeilenObjekt implements ITabellenZeile
{
	/**
	 * Objekt, zu dem diese Zeile gehrt. Knnte z.B. ein Systemobjekt sein.
	 */
	private Object _zeilenObjekt = null;

	/**
	 * Attributliste mit der aktuellen Ausprgung der Attribute des jeweiligen
	 * Bezugsobjektes.
	 */
	private Object[] _attributListe = null;

	public ZeilenObjekt(Object zeilenObjekt, Object[] attributListe)
	{
		_zeilenObjekt = zeilenObjekt;
		_attributListe = attributListe;
	}

	@Override
	public int getAnzahlAttribute()
	{
		int re = 0;
		if (_attributListe != null)
		{
			re = _attributListe.length;
		}
		return re;
	}

	@Override
	public Object getAttribut(int idx)
	{
		Object re = null;
		if (_attributListe != null)
		{
			if (idx < _attributListe.length)
			{
				re = _attributListe[idx];
			}
		}
		return re;
	}

	@Override
	public int[] getZuBeruecksichtigendeAttribute()
	{
		// int[] re = new int[_attributListe.length];
		// for (int i = 0; i < _attributListe.length; i++)
		// {
		// re[i] = i;
		// }

		int[] re = new int[] { 2, 3, 4 };

		return re;
	}

	@Override
	public Object getZeilenObject()
	{
		return _zeilenObjekt;
	}

	@Override
	public int compareTo(ITabellenZeile o)
	{
		int re = 0;

		boolean ungleich = false;
		if (this.getAnzahlAttribute() == o.getAnzahlAttribute())
		{
			for (int i = 0; i < this.getAnzahlAttribute(); i++)
			{
				if (!o.getAttribut(i).equals(this.getAttribut(i)))
				{
					ungleich = true;
					break;
				}
			}

			if (ungleich)
			{
				re = 1;
			}
		}

		return re;
	}

}
