/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.listendarstellung;

import java.util.Iterator;
import java.util.LinkedList;

public class TestListenDarstellungBestimmeKopfzeilen
{

  /**
   * @param args
   */
  public static void main(String[] args)
  {
    @SuppressWarnings("unused")
    TestListenDarstellungBestimmeKopfzeilen te = new TestListenDarstellungBestimmeKopfzeilen();
  }

  public TestListenDarstellungBestimmeKopfzeilen()
  {
    /*
     * Verbindungsaufbau
     */
    DaVComListendarstellungstest dav = new DaVComListendarstellungstest();
    dav.baueVerbindungMitDaVAuf();

    /*
     * Header bestimmen
     */
    ListenDarstellungBestimmeKopfzeilen kopfzeilen = new ListenDarstellungBestimmeKopfzeilen(dav.getVerbindung());
    kopfzeilen.setDaten("typ.messQuerschnitt", "atg.anteilLkwFuzzy", "asp.parameterDefault");
    // kopfzeilen.setDaten("typ.autarkeOrganisationsEinheit",
    // "atg.benutzerEinstellungenOberflcheNetzweit", "asp.parameterDefault");
    kopfzeilen.bestimmeAttributeEinerAttributGruppe();

    /*
     * Bestimmen der tiefsten Ebene
     */
    Knoten wurzelKnoten = kopfzeilen.getWurzelKnoten();

    int breitesteEbene = wurzelKnoten.bestimmeBreitesteEbene();
    System.out.println("Breite der breitesten Ebene: " + breitesteEbene);

    LinkedList<Knoten> knotenOhneNachfolger = wurzelKnoten.bestimmeKnotenOhneNachfolger();
    System.out.println("Anzahl Knoten ohne Nachfolger: " + knotenOhneNachfolger.size());
    Iterator<Knoten> itKnotenOhneNachfolger = knotenOhneNachfolger.iterator();
    int i = 0;
    while (itKnotenOhneNachfolger.hasNext())
    {
      Knoten einzelnerKnotenOhneNachfolger = itKnotenOhneNachfolger.next();
      System.out.println("Knoten ohne Nachfolger " + i + ": " + einzelnerKnotenOhneNachfolger);
      i++;
    }

    /*
     * Verbindungsabbau
     */
    dav.trenneDaVVerbindung();
  }

}
