/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.seiteneinstellungen.druck.vorschau;

/**
 * Definitionen von Feldern und regulren Ausdrcken.
 * 
 * @author HofmannJ
 * 
 */
public class Defs
{
	/**
	 * Feld [Seite]
	 */
	protected static final String FELD_SEITE = "[Seite]";

	/**
	 * Feld [Seitenanzahl]
	 */
	protected static final String FELD_SEITEN_ANZAHL = "[Seitenanzahl]";

	/**
	 * Feld [Datum]
	 */
	protected static final String FELD_DATUM = "[Datum]";

	/**
	 * Feld [Uhrzeit]
	 */
	protected static final String FELD_UHRZEIT = "[Uhrzeit]";

	/**
	 * Feld [Titel]
	 */
	protected static final String FELD_TITEL = "[Titel]";

	/**
	 * Regulrer Ausdruck zum Suchen nach dem String [Seite].
	 */
	protected static final String REGEX_SEITE = "\\[Seite\\]";

	/**
	 * Regulrer Ausdruck zum Suchen nach dem String [Seitenanzahl].
	 */
	protected static final String REGEX_SEITEN_ANZAHL = "\\[Seitenanzahl\\]";

	/**
	 * Regulrer Ausdruck zum Suchen nach dem String [Datum].
	 */
	protected static final String REGEX_DATUM = "\\[Datum\\]";

	/**
	 * Regulrer Ausdruck zum Suchen nach dem String [Uhrzeit].
	 */
	protected static final String REGEX_UHRZEIT = "\\[Uhrzeit\\]";

	/**
	 * Regulrer Ausdruck zum Suchen nach dem String [Titel].
	 */
	protected static final String REGEX_TITEL = "\\[Titel\\]";
}
