/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.rw.dav;

import de.bsvrz.sys.funclib.debug.Debug;

public class DaVVerbindungTrennThread implements Runnable
{

  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();

  private static DaVVerbindungTrennThread _instanz = null;

  private boolean _laufe = false;

  private DaVVerbindung _dav = null;

  public static DaVVerbindungTrennThread getInstanz()
  {
    if (_instanz == null)
    {
      _instanz = new DaVVerbindungTrennThread();
    }
    return _instanz;
  }

  private DaVVerbindungTrennThread()
  {
    _debug.fine("DaVVerbindungTrennThread.DaVVerbindungTrennThread() => INITIALISIERE");
    _dav = DaVVerbindung.getInstanz();
  }

  public void starteThread()
  {
    if (!_laufe)
    {
      _laufe = true;

      Thread th = new Thread(this);
      th.setName(getClass().getName());

      // Display.getDefault().syncExec(th);
//      Display.getDefault().asyncExec(th);
      th.start();

    }
    else
    {
      _debug.fine("DaVVerbindungTrennThread.starteThread() => Thread luft bereits.");
    }
  }

  public void run()
  {
    while (_laufe)
    {    	
      _debug.fine("DaVVerbindungTrennThread.run() => _threadVorgangDaVVerbindungTrennen");

      if (_dav.istTrennenOk())
      {
        _debug.fine("DaVVerbindung.run() => istTrennenOk");

        _dav._davVerbindungTrennenOk = true;
//        _dav.trenneDaVVerbindungSWTThreadsicher();
        _dav.trenneDaVVerbindung();
        _laufe = false;
        
        synchronized (this)
				{
					notifyAll();
				}
      }

//      Display.getDefault().readAndDispatch();

      try
      {
        Thread.sleep(10);
      }
      catch (InterruptedException e)
      {
        //
      }
    }

  }

}
