/*
 * This file is part of Rahmenwerk.
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 * 
 * Copyright (c) 2012 Swarco Traffic Systems GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * Swarco Traffic Systems GmbH - initial API and implementation
 * 
 * 
 * 
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae
 * D-76571 Gaggenau 
 * T. +49 (0)7225 / 64-03
 * F. +49 (0)7225 / 64-300 
 * E. office.sts@swarco.de
 */
package de.sts.esptool.dlgs;

/**
 * Enumerator zur Bestimmung, fr welches "Subjekt" gespeichert werden soll.
 * 
 * @author HofmannJ
 * 
 */
public enum EnumSubjekt
{
	/**
	 * Angemeldeter Benutzer
	 */
	benutzerAngemeldet("Angemeldeter Benutzer", "Angemeldeter Benutzer"),

	/**
	 * Benutzer aus AuswahlDialog
	 */
	benutzerAuswahl("Benutzer Auswahl",
			"Auswahl des Benutzers erfolgt ber einen Dialog o.."),

	/**
	 * Allgemein
	 */
	allgemein("Allgemein", "Allgemeiner Einstellungenspeicher");

	private String _bezeichnung = null;
	private String _beschreibung = null;

	/**
	 * Konstruktor. bernimmt Bezeichnung und Beschreibung dieses Enumerators.
	 * 
	 * @param bezeichnung
	 *          Bezeichnung
	 * @param beschreibung
	 *          Beschreibung
	 */
	private EnumSubjekt(String bezeichnung, String beschreibung)
	{
		this._bezeichnung = bezeichnung;
		this._beschreibung = beschreibung;
	}

	/**
	 * Liefert die Bezeichnung dieses Enumerators.
	 * 
	 * @return Bezeichnung
	 */
	public String getBezeichnung()
	{
		return _bezeichnung;
	}

	/**
	 * Liefert die Beschreibung dieses Enumerators.
	 * 
	 * @return Beschreibung
	 */
	public String getBeschreibung()
	{
		return _beschreibung;
	}

	public String toString()
	{
		return _bezeichnung;
	}
}
